/* File Type Function
 *
 * 11/22/2020
 *
 * int ftype(file) -- returns type of file:
 * 
 * 		  1 - directory
 * 		  0 - file
 * 		 -1 - does not exist
 *
 * ftype.c
 */

#include <sys/stat.h>

#include "ftype.h"

int ftype(char file[])
{
	struct stat statbuf;
	int s = stat(file, &statbuf);
	if (s != 0)
	{
		return _NONE;
	}
	if (S_ISREG (statbuf.st_mode)) 
	{
		return _FILE;
	} else if (S_ISDIR (statbuf.st_mode)) 
	{
		return _DIR;
	} else {
		return _NONE;
	}
}
