/* Centaur MD5
 *
 * Version 2.0
 * 11/22/2020
 *
 * Main program
 *
 * main.c
 */

#include <ctype.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <fcntl.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <openssl/md5.h>

#include "md5.h"

#define _USAGE "Usage: %s <file ...>\n       %s -L <file>\n       %s -s/-S '<string>'\n"

int main(int argc, char *argv[])
{
	if (argc < 2)
	{
		printf(_USAGE, argv[0], argv[0], argv[0]);
		return 1;
	}

	int a;
	for (a = 1; a <= (argc - 1); a++)
	{
		if (argc == 3 && !strcmp(argv[1], "-s")) {
			strcpy(r, md5string(argv[2], 0));
			printf("%s\n", r);
			return 0;
		} else if (argc == 3 && !strcmp(argv[1], "-S")) {
			strcpy(r, md5string(argv[2], 1));
			printf("%s\n", r);
			return 0;
		} else if (argc == 3 && !strcmp(argv[1], "-L")) {
			strcpy(r, md5file(argv[2]));
			printf("%s\n", r);
			return 0;
		} else if (argc > 3 && (!strcmp(argv[1], "-s") || !strcmp(argv[1], "-S") || !strcmp(argv[1], "-L"))) {
			printf("%s: too many arguments used with option %s\n", argv[0], argv[1]);
			return 1;
		}
		
		if (argc >= 2)
		{
			strcpy(r, md5file(argv[a]));
			printf("%s  %s\n", r, argv[a]);
			continue;
			
		} else {
			printf(_USAGE, argv[0], argv[0], argv[0]);
			return 1;
		}
	}
}
