/* Centaur MD5
 *
 * Version 2.0
 * 11/22/2020
 *
 * Functions for checking MD5 sums of files and strings
 *
 * md5.c
 */

#include <ctype.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <fcntl.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <openssl/md5.h>

#include "ftype.h"
#include "md5.h"

char * md5string(char string[], int uppercase)
{
	int i;
	unsigned char digest[16];
	static char md5str[33];
	static char md5str_u[33];
	MD5_CTX context;
	MD5_Init(&context);
	MD5_Update(&context, string, strlen(string));
	MD5_Final(digest, &context);
	for(i = 0; i < 16; i++)
	{
	    sprintf(&md5str[i*2], "%02x", (unsigned int)digest[i]);
	}
	if (uppercase)
	{
		for (i = 0; i < strlen(md5str); i++)
		{
			md5str_u[i] = toupper(md5str[i]);
		}
		return md5str_u;
	} else {
		return md5str;
	}
}

unsigned long fdsize(int fd)
{
	struct stat statbuf;
	if (fstat(fd, &statbuf) < 0)
	{
		return -1;
	}
	return statbuf.st_size;
}

char * md5file(char fname[])
{
	if (ftype(fname) == _DIR)
	{
		return "(directory)                     ";
	}

	int i;
	int file_descript;
	unsigned long file_size;
	char* file_buffer;

	file_descript = open(fname, O_RDONLY);
	if (file_descript < 0)
	{
		return "(file access error)             ";
	}

	file_size = fdsize(file_descript);

	file_buffer = mmap(0, file_size, PROT_READ, MAP_SHARED, file_descript, 0);
	MD5((unsigned char*) file_buffer, file_size, result);
	munmap(file_buffer, file_size); 

	for(i = 0; i < MD5_DIGEST_LENGTH; i++)
	{
		sprintf(&md5f_retv[i*2], "%02x", result[i]);
	}

	return md5f_retv;
}
