/* Centaur MD5
 *
 * Version 2.0
 * 11/22/2020
 *
 * Simplified MD5 functions
 *
 * md5string(string, case)	-- get MD5 hash of string
 * md5file(file)		-- get MD5 hash of file
 *
 * Return values are always strings.
 *
 * 'case' must be provided for md5string(); 0 = lowercase, 1 = uppercase
 * 'file' must be a path to a file and not a file descriptor/stream
 *
 * md5.h
 */

#ifndef _CENTAUR_MD5_H
#define _CENTAUR_MD5_H 1

unsigned char result[MD5_DIGEST_LENGTH];
char md5f_retv[33];
char r[33];

char * md5string(char string[], int uppercase);

unsigned long fdsize(int fd);

char * md5file(char fname[]);

#endif /* _CENTAUR_MD5_H */
